## hdrmerge 0.5%2Bgit20200117

=== debian/changelog ===
hdrmerge (0.5+git20200117-2build4) jammy; urgency=medium

  * No-change rebuild against libalglib3.18

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 06 Jan 2022 07:21:00 +0000

hdrmerge (0.5+git20200117-2build3) hirsute; urgency=medium

  * No-change rebuild to pick up new libraw soname

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Fri, 05 Mar 2021 14:57:38 +0100

hdrmerge (0.5+git20200117-2build2) hirsute; urgency=medium

  * No-change rebuild for alglib soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Jan 2021 15:38:12 +0100

hdrmerge (0.5+git20200117-2build1) focal; urgency=medium

  * No-change rebuild for exiv2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 04 Feb 2020 20:21:09 +0100

hdrmerge (0.5+git20200117-2) unstable; urgency=medium

  * Add Vcs fields.
  * Bump standards version to 4.5.0.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 03 Feb 2020 11:13:27 +0100

hdrmerge (0.5+git20200117-1) experimental; urgency=medium

  * Initial release. (Closes: #949362)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 17 Jan 2020 21:04:46 +0100
