=== debian/changelog ===
hdrmerge (0.5+git20200117-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream commit 377d8e6f3c7cdd1a45b63bce2493ad177dde03fb to make
    hdrmerge compatible with Exiv2 0.28+; patch
    0001-Adapt-to-Exiv2-0.28.0-API-change.patch (Closes: #1071027)

 -- Pino Toscano <pino@debian.org>  Tue, 03 Sep 2024 07:22:48 +0200

hdrmerge (0.5+git20200117-4) unstable; urgency=medium

  * Ack NMU.
  * Bump standards version to 4.7.0.
  * Bump debhelper version to 13.

 -- Alex Myczko <tar@debian.org>  Sun, 16 Jun 2024 21:12:31 +0000

hdrmerge (0.5+git20200117-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/221.patch:
    - cherry-pick upstream proposed patch to fix gcc-13 build failure (Closes:
      #1037686)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 16 Jul 2023 21:12:40 +0200

hdrmerge (0.5+git20200117-3) unstable; urgency=medium

  * Team upload.

  * debian/patches/: patchset updated (Closes: #1040256)
    - 0001-Fix-LibRaw-0.21-API-change.patch added

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 07 Jul 2023 22:22:08 +0200
