=== debian/control ===
Source: hdrmerge
Section: graphics
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Alex Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libalglib-dev, qtbase5-dev, libraw-dev, libexiv2-dev, zlib1g-dev
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/multimedia-team/hdrmerge.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/hdrmerge
Homepage: https://github.com/jcelaya/hdrmerge

Package: hdrmerge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: HDR exposure merging
 This combines two or more raw images into a single raw with an extended
 dynamic range. It can import any raw image supported by LibRaw, and outputs
 a DNG 1.4 image with floating point data. The output raw is built from the
 less noisy pixels of the input, so that shadows maintain as much detail as
 possible. This tool also offers a GUI to remove ghosts from the resulting
 image.
